------------------------------------------------------------------
--                                                              --
--  File:   Create_Clustered_Indexes_Growing.SQL                --
--          Microsoft TPC-E Benchmark Kit Ver. 1.2.0-1000       --
--          Copyright Microsoft, 2006, 2007                     --
--                                                              --
--  NOTE:   This file is modified by TPCE_SETUP.CMD based on    --
--          the number of processors on the system.             --
--          Generating this file allows the proper setting      --
--          of the MAXDOP=8)
--                                                              --
------------------------------------------------------------------
USE tpce
GO
 
---
--- Set connection attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- *** BROKER ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_BROKER' )
    CREATE UNIQUE CLUSTERED INDEX PK_BROKER ON BROKER(B_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO 

-- *** TRADE_HISTORY ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_TRADE_HISTORY' )
    CREATE UNIQUE CLUSTERED INDEX PK_TRADE_HISTORY ON TRADE_HISTORY(TH_T_ID, TH_ST_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO

-- *** CASH_TRANSACTION *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_CASH_TRANSACTION' )
    CREATE UNIQUE CLUSTERED INDEX PK_CASH_TRANSACTION ON CASH_TRANSACTION(CT_T_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO

-- *** SETTLEMENT *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_SETTLEMENT' )
    CREATE UNIQUE CLUSTERED INDEX PK_SETTLEMENT ON SETTLEMENT(SE_T_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO

-- *** HOLDING *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_HOLDING' )
    CREATE UNIQUE CLUSTERED INDEX PK_HOLDING ON HOLDING(H_T_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON customer_fg
GO

-- *** HOLDING_HISTORY *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_HOLDING_HISTORY' )
    CREATE UNIQUE CLUSTERED INDEX PK_HOLDING_HISTORY ON HOLDING_HISTORY(HH_H_T_ID, HH_T_ID)
        WITH (FILLFACTOR=95, MAXDOP=8)
        ON customer_fg
GO

-- *** HOLDING_SUMMARY *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_HOLDING_SUMMARY' )
    CREATE UNIQUE CLUSTERED INDEX PK_HOLDING_SUMMARY ON HOLDING_SUMMARY(HS_CA_ID, HS_S_SYMB)
        WITH (FILLFACTOR=95, MAXDOP=8)
        ON customer_fg
GO

-- *** TRADE *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_TRADE' )
    CREATE UNIQUE CLUSTERED INDEX PK_TRADE ON TRADE(T_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO

-- *** TRADE_REQUEST *** 
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'PK_TRADE_REQUEST' )
    CREATE UNIQUE CLUSTERED INDEX PK_TRADE_REQUEST ON TRADE_REQUEST(TR_T_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON broker_fg
GO
