------------------------------------------------------------------
--                                                              --
--  File:   Create_NC_Indexes_Scaling.SQL                       --
--          Microsoft TPC-E Benchmark Kit Ver. 1.2.0-1000       --
--         Copyright Microsoft, 2006, 2007                      --
--                                                              --
--  NOTE:   This file is generated by TPCE_SETUP.CMD based on   --
--          the number of processors on the system.             --
--          Generating this file allows the proper setting      --
--          of the MAXDOP=8)
--                                                              --
------------------------------------------------------------------
USE tpce
GO

---
--- Set connection attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- *** COMPANY ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'COMPANY_NC1' )
    CREATE UNIQUE INDEX COMPANY_NC1 ON COMPANY(CO_NAME, CO_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON market_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'COMPANY_NC2' )
    CREATE UNIQUE INDEX COMPANY_NC2 ON COMPANY(CO_IN_ID, CO_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON market_fg
GO

-- *** COMPANY_COMPETITOR ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'COMPANY_COMP_NC1' )
    CREATE INDEX COMPANY_COMP_NC1 ON COMPANY_COMPETITOR(CP_CO_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON market_fg
GO

-- *** DAILY_MARKET ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'DAILY_MARKET_NC1' )
    CREATE UNIQUE INDEX DAILY_MARKET_NC1 ON DAILY_MARKET(DM_DATE, DM_S_SYMB)
        WITH (FILLFACTOR=100, MAXDOP=8, SORT_IN_TEMPDB=ON)
        ON market_fg
GO

-- *** CUSTOMER ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'CUSTOMER_NC1' )
    CREATE UNIQUE INDEX CUSTOMER_NC1 ON CUSTOMER(C_TAX_ID, C_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON customer_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'CUSTOMER_NC2' )
    CREATE UNIQUE INDEX CUSTOMER_NC2 ON CUSTOMER(C_ID, C_TIER)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON customer_fg
GO

-- *** CUSTOMER_ACCOUNT ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'CUSTOMER_ACCOUNT_NC1' )
    CREATE UNIQUE INDEX CUSTOMER_ACCOUNT_NC1 ON CUSTOMER_ACCOUNT(CA_C_ID, CA_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON customer_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'CUSTOMER_ACCOUNT_NC2' )
    CREATE UNIQUE INDEX CUSTOMER_ACCOUNT_NC2 ON CUSTOMER_ACCOUNT(CA_B_ID, CA_ID, CA_C_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
	    ON customer_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'CUSTOMER_ACCOUNT_NC3' )
    CREATE UNIQUE INDEX CUSTOMER_ACCOUNT_NC3 ON CUSTOMER_ACCOUNT(CA_ID, CA_B_ID, CA_C_ID, CA_TAX_ST, CA_NAME)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON customer_fg
GO

-- *** SECURITY ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'SECURITY_NC1' )
    CREATE UNIQUE INDEX SECURITY_NC1 ON SECURITY(S_CO_ID, S_ISSUE, S_EX_ID, S_SYMB)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON market_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'SECURITY_NC2' )
    CREATE UNIQUE INDEX SECURITY_NC2 ON SECURITY(S_CO_ID, S_NUM_OUT, S_SYMB)
        WITH (FILLFACTOR=100, MAXDOP=8)
    	ON market_fg
GO

-- *** WATCH_LIST ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'WATCH_LIST_NC1' )
    CREATE UNIQUE INDEX WATCH_LIST_NC1 ON WATCH_LIST(WL_C_ID, WL_ID)
        WITH (FILLFACTOR=100, MAXDOP=8)
        ON customer_fg
GO
