------------------------------------------------------------------
--                                                              --
--  File:   Drop_Tables_and_Constraints_Fixed.SQL               --
--          Microsoft TPC-E Benchmark Kit Ver. 1.2.0-1000       --
--         Copyright Microsoft, 2006, 2007                      --
--                                                              --
------------------------------------------------------------------
USE tpce
GO

---
--- Set connection attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- ************************************
-- *** DROP FOREIGN KEY CONSTRAINTS ***
-- ************************************

-- *** EXCHANGE ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMMISSION_RATE_EXCHANGE' )
	ALTER TABLE COMMISSION_RATE DROP CONSTRAINT FK_COMMISSION_RATE_EXCHANGE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_SECURITY_EXCHANGE' )
	ALTER TABLE SECURITY DROP CONSTRAINT FK_SECURITY_EXCHANGE
GO

-- *** INDUSTRY ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_COMP_INDUSTRY' )
	ALTER TABLE COMPANY_COMPETITOR DROP CONSTRAINT FK_COMPANY_COMP_INDUSTRY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_INDUSTRY_SECTOR' )
	ALTER TABLE INDUSTRY DROP CONSTRAINT FK_INDUSTRY_SECTOR
GO

-- *** STATUS_TYPE ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_BROKER_STATUS' )
	ALTER TABLE BROKER DROP CONSTRAINT FK_BROKER_STATUS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_STATUS' )
	ALTER TABLE COMPANY DROP CONSTRAINT FK_COMPANY_STATUS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_STATUS_TYPE' )
	ALTER TABLE CUSTOMER DROP CONSTRAINT FK_CUSTOMER_STATUS_TYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_SECURITY_STATUS' )
	ALTER TABLE SECURITY DROP CONSTRAINT FK_SECURITY_STATUS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_STATUS' )
	ALTER TABLE TRADE DROP CONSTRAINT FK_TRADE_STATUS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_HISTORY_STATUS' )
	ALTER TABLE TRADE_HISTORY DROP CONSTRAINT FK_TRADE_HISTORY_STATUS
GO

-- *** TAXRATE ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_TAXRATE_TAX' )
	ALTER TABLE CUSTOMER_TAXRATE DROP CONSTRAINT FK_CUSTOMER_TAXRATE_TAX
GO

-- *** TRADE_TYPE ***

IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CHARGE_TRADETYPE' )
	ALTER TABLE CHARGE DROP CONSTRAINT FK_CHARGE_TRADETYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMMISSION_RATE_TRADETYPE' )
	ALTER TABLE COMMISSION_RATE DROP CONSTRAINT FK_COMMISSION_RATE_TRADETYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_TRADETYPE' )
	ALTER TABLE TRADE DROP CONSTRAINT FK_TRADE_TRADETYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_REQUEST_TRADETYPE' )
	ALTER TABLE TRADE_REQUEST DROP CONSTRAINT FK_TRADE_REQUEST_TRADETYPE
GO

-- *** ZIP_CODE
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_ADDRESS_ZIP_CODE' )
	ALTER TABLE ADDRESS DROP CONSTRAINT FK_ADDRESS_ZIP_CODE
GO

-- **************************
-- *** DROP FIXED TABLES ***
-- **************************
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'CHARGE' )
	DROP TABLE CHARGE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'COMMISSION_RATE' )
	DROP TABLE COMMISSION_RATE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'EXCHANGE' )
	DROP TABLE EXCHANGE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'INDUSTRY' )
	DROP TABLE INDUSTRY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'SECTOR' )
	DROP TABLE SECTOR
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'STATUS_TYPE' )
	DROP TABLE STATUS_TYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'TAXRATE' )
	DROP TABLE TAXRATE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'TRADE_TYPE' )
	DROP TABLE TRADE_TYPE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'ZIP_CODE' )
	DROP TABLE ZIP_CODE
GO


