------------------------------------------------------------------
--                                                              --
--  File:   Drop_Tables_and_Constraints_Growing.SQL             --
--          Microsoft TPC-E Benchmark Kit Ver. 1.2.0-1000       --
--         Copyright Microsoft, 2006, 2007                      --
--                                                              --
------------------------------------------------------------------
USE tpce
GO

---
--- Set connection attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- ************************************
-- *** DROP FOREIGN KEY CONSTRAINTS ***
-- ************************************
-- *** BROKER ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_ACCOUNT_BROKER' )
	ALTER TABLE CUSTOMER_ACCOUNT DROP CONSTRAINT FK_CUSTOMER_ACCOUNT_BROKER
GO

-- *** TRADE ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CASH_TRANSACTION_TRADE' )
	ALTER TABLE CASH_TRANSACTION DROP CONSTRAINT FK_CASH_TRANSACTION_TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_TRADE' )
	ALTER TABLE HOLDING DROP CONSTRAINT FK_HOLDING_TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_HISTORY_TRADE1' )
	ALTER TABLE HOLDING_HISTORY DROP CONSTRAINT FK_HOLDING_HISTORY_TRADE1
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_HISTORY_TRADE2' )
	ALTER TABLE HOLDING_HISTORY DROP CONSTRAINT FK_HOLDING_HISTORY_TRADE2
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_HISTORY_TRADE' )
	ALTER TABLE TRADE_HISTORY DROP CONSTRAINT FK_TRADE_HISTORY_TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_REQUEST_TRADE' )
	ALTER TABLE TRADE_REQUEST DROP CONSTRAINT FK_TRADE_REQUEST_TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_SETTLEMENT_TRADE' )
	ALTER TABLE SETTLEMENT DROP CONSTRAINT FK_SETTLEMENT_TRADE
GO

-- ***************************
-- *** DROP GROWING TABLES ***
-- ***************************
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'BROKER' )
	DROP TABLE BROKER
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'CASH_TRANSACTION' )
	DROP TABLE CASH_TRANSACTION
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'HOLDING' )
	DROP TABLE HOLDING
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'HOLDING_HISTORY' )
	DROP TABLE HOLDING_HISTORY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'HOLDING_SUMMARY' )
	DROP TABLE HOLDING_SUMMARY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'SETTLEMENT' )
	DROP TABLE SETTLEMENT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'TRADE' )
	DROP TABLE TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'TRADE_HISTORY' )
	DROP TABLE TRADE_HISTORY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'TRADE_REQUEST' )
	DROP TABLE TRADE_REQUEST
GO
