------------------------------------------------------------------
--                                                              --
--  File:   Drop_Tables_and_Constraints_Scaling.SQL             --
--          Microsoft TPC-E Benchmark Kit Ver. 1.2.0-1000       --
--         Copyright Microsoft, 2006, 2007                      --
--                                                              --
------------------------------------------------------------------
USE tpce
GO

---
--- Set connection attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- ************************************
-- *** DROP FOREIGN KEY CONSTRAINTS ***
-- ************************************
-- *** ADDRESS ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_ADDRESS' )
	ALTER TABLE COMPANY DROP CONSTRAINT FK_COMPANY_ADDRESS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_ADDRESS' )
	ALTER TABLE CUSTOMER DROP CONSTRAINT FK_CUSTOMER_ADDRESS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_EXCHANGE_ADDRESS' )
	ALTER TABLE EXCHANGE DROP CONSTRAINT FK_EXCHANGE_ADDRESS
GO

-- *** COMPANY ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_COMP_COMPANY1' )
	ALTER TABLE COMPANY_COMPETITOR DROP CONSTRAINT FK_COMPANY_COMP_COMPANY1
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_COMP_COMPANY2' )
	ALTER TABLE COMPANY_COMPETITOR DROP CONSTRAINT FK_COMPANY_COMP_COMPANY2
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_COMPANY_INDUSTRY_COMPANY' )
	ALTER TABLE COMPANY_INDUSTRY DROP CONSTRAINT FK_COMPANY_INDUSTRY_COMPANY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_FINANCIAL_COMPANY' )
	ALTER TABLE FINANCIAL DROP CONSTRAINT FK_FINANCIAL_COMPANY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_NEWS_XREF_COMPANY' )
	ALTER TABLE NEWS_XREF DROP CONSTRAINT FK_NEWS_XREF_COMPANY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_SECURITY_COMPANY' )
	ALTER TABLE SECURITY DROP CONSTRAINT FK_SECURITY_COMPANY
GO

-- *** CUSTOMER ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_ACCOUNT_CUSTOMER' )
	ALTER TABLE CUSTOMER_ACCOUNT DROP CONSTRAINT FK_CUSTOMER_ACCOUNT_CUSTOMER
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CUSTOMER_TAXRATE_CUSTOMER' )
	ALTER TABLE CUSTOMER_TAXRATE DROP CONSTRAINT FK_CUSTOMER_TAXRATE_CUSTOMER
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_WATCH_LIST_CUSTOMER' )
	ALTER TABLE WATCH_LIST DROP CONSTRAINT FK_WATCH_LIST_CUSTOMER
GO

-- *** CUSTOMER_ACCOUNT ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_ACCOUNT_PERMISSION_CUSTOMER_ACCOUNT' )
	ALTER TABLE ACCOUNT_PERMISSION DROP CONSTRAINT FK_ACCOUNT_PERMISSION_CUSTOMER_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_CASH_TRANSACTION_ACCOUNT' )
	ALTER TABLE CASH_TRANSACTION DROP CONSTRAINT FK_CASH_TRANSACTION_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_CUSTOMER_ACCOUNT' )
	ALTER TABLE HOLDING DROP CONSTRAINT FK_HOLDING_CUSTOMER_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_SUMMARY_ACCOUNT' )
	ALTER TABLE HOLDING_SUMMARY DROP CONSTRAINT FK_HOLDING_SUMMARY_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_CUSTOMER_ACCOUNT' )
	ALTER TABLE TRADE DROP CONSTRAINT FK_TRADE_CUSTOMER_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_REQUEST_CUSTOMER_ACCOUNT' )
	ALTER TABLE TRADE_REQUEST DROP CONSTRAINT FK_TRADE_REQUEST_CUSTOMER_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_SETTLEMENT_CUSTOMER_ACCOUNT' )
	ALTER TABLE SETTLEMENT DROP CONSTRAINT FK_SETTLEMENT_CUSTOMER_ACCOUNT
GO

-- *** NEWS_ITEM ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_NEWS_XREF_NEWS_ITEM' )
	ALTER TABLE NEWS_XREF DROP CONSTRAINT FK_NEWS_XREF_NEWS_ITEM
GO

-- *** SECURITY ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_DAILY_MARKET_SECURITY' )
	ALTER TABLE DAILY_MARKET DROP CONSTRAINT FK_DAILY_MARKET_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_SECURITY' )
	ALTER TABLE HOLDING DROP CONSTRAINT FK_HOLDING_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_HOLDING_SUMMARY_SECURITY' )
	ALTER TABLE HOLDING_SUMMARY DROP CONSTRAINT FK_HOLDING_SUMMARY_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_LAST_TRADE_SECURITY' )
	ALTER TABLE LAST_TRADE DROP CONSTRAINT FK_LAST_TRADE_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_SECURITY' )
	ALTER TABLE TRADE DROP CONSTRAINT FK_TRADE_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_TRADE_REQUEST_SECURITY' )
	ALTER TABLE TRADE_REQUEST DROP CONSTRAINT FK_TRADE_REQUEST_SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_WATCH_ITEM_SECURITY' )
	ALTER TABLE WATCH_ITEM DROP CONSTRAINT FK_WATCH_ITEM_SECURITY
GO

-- *** WATCH_LIST ***
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FK_WATCH_ITEM_WATCHLIST' )
	ALTER TABLE WATCH_ITEM DROP CONSTRAINT FK_WATCH_ITEM_WATCHLIST
GO

-- ***************************
-- *** DROP SCALING TABLES ***
-- ***************************
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'ACCOUNT_PERMISSION' )
	DROP TABLE ACCOUNT_PERMISSION
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'ADDRESS' )
	DROP TABLE ADDRESS
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'COMPANY' )
	DROP TABLE COMPANY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'COMPANY_COMPETITOR' )
	DROP TABLE COMPANY_COMPETITOR
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'CUSTOMER' )
	DROP TABLE CUSTOMER
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'CUSTOMER_ACCOUNT' )
	DROP TABLE CUSTOMER_ACCOUNT
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'CUSTOMER_TAXRATE' )
	DROP TABLE CUSTOMER_TAXRATE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'DAILY_MARKET' )
	DROP TABLE DAILY_MARKET
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'FINANCIAL' )
	DROP TABLE FINANCIAL
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'LAST_TRADE' )
	DROP TABLE LAST_TRADE
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'NEWS_ITEM' )
	DROP TABLE NEWS_ITEM
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'NEWS_XREF' )
	DROP TABLE NEWS_XREF
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'SECURITY' )
	DROP TABLE SECURITY
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'WATCH_ITEM' )
	DROP TABLE WATCH_ITEM
GO
IF EXISTS ( SELECT name FROM sysobjects WHERE name = 'WATCH_LIST' )
	DROP TABLE WATCH_LIST
GO
