'----------------------------------------------------------------------------------------
'---  FILE:       ACIDPROC.VBS
'---              Microsoft TPC-E Kit Ver. 1.2.0-1000
'---              Copyright Microsoft, 2006, 2007
'---              All Rights Reserved
'---
'---  PURPOSE:    This module installs the TPC-E ACID Stored Procedure
'---
'----------------------------------------------------------------------------------------
'------------------------------------
'--- open an windows scripting object
'------------------------------------
set WshShell = CreateObject("WScript.Shell")
'-----------------------------------------------------
'--- set up windows scripting argument collection
'-----------------------------------------------------
Set objArgs = wScript.Arguments
'-----------------------------
'--- set the test particulars
'-----------------------------
Kit_Version = "  1.2.0-1000"
Test_Name = "ACID Stored Procedures"
Header_Line = "*  Installing TPC-E ACID Stored Procedures...                              *"
Footer_Line = "*  TPC-E ACID Stored Procedures Installed.                                 *"
Status_Line = "Installing ACID Stored Procedures..."
'------------------------------------
'--- display banner message
'------------------------------------
wScript.Echo "****************************************************************************"
wScript.Echo "*                                                                          *"
wScript.Echo "*  Microsoft TPC-E Benchmark Kit Ver." & Kit_Version & "                          *"
wScript.Echo "*                                                                          *"
wScript.Echo Header_Line
wScript.Echo "*                                                                          *"
wScript.Echo "****************************************************************************"
'----------------------------------------------
'--- build array of Acid stored procedure names
'----------------------------------------------
Dim AcidProcArray(14)
AcidProcArray(0) = "TradeOrder_C"
AcidProcArray(1) = "TradeOrder_RB"
AcidProcArray(2) = "TradeOrder_Iso1_1"
AcidProcArray(3) = "TradeOrder_Iso1_2"
AcidProcArray(4) = "TradeOrder_Iso2"
AcidProcArray(5) = "TradeOrder_Iso3"
AcidProcArray(6) = "TradeOrder_Iso4"
AcidProcArray(7) = "TradeResult_Iso1_1"
AcidProcArray(8) = "TradeResult_Iso1_2"
AcidProcArray(9) = "TradeResult_Iso2_1"
AcidProcArray(10) = "TradeResult_Iso2_2"
AcidProcArray(11) = "TradeResult_Iso3"
AcidProcArray(12) = "TradeResult_Iso4"
AcidProcArray(13) = "CustomerPosition_Iso3"
AcidProcArray(14) = "CustomerPosition_Iso4"

'------------------------------------
'--- grab the current directory value
'------------------------------------
AcidProcDirectory = WshShell.CurrentDirectory & "\"
'----------------------------------------------------------------------
'--- check to see if the user passed in the server name and sa password
'----------------------------------------------------------------------
Select Case objArgs.Length
	Case 0
		'----------------------------------------
		'--- the user did not pass us anything
		'--- grab the Computer Name from Windows
		'----------------------------------------
		ServerName = WshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
		'----------------------------------------------
		'--- prompt the user to confirm the server name
		'----------------------------------------------
		ServerName = InputBox("Enter your server name",Test_Name,ServerName)
		Do While ServerName = ""
			rc = MsgBox ("You must enter a valid server name.",21)
			If rc = 2 Then
				wScript.Echo ""
				wScript.Echo "TPC-C Setup cancelled by user."
				wScript.Quit
			End If	
			ServerName = WshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
			ServerName = InputBox("Enter your server name","Database Server Name",ServerName)
		Loop
		'---------------------------------------
		'--- prompt the user for the sa password
		'---------------------------------------
		saPassword = InputBox("Enter the 'sa' password",Test_Name)
		If saPassword = "" Then
			saPassword = "Blank"
		End If
	Case 1
		'----------------------------------------------------------------
		'--- the user passed 1 argument, so assume it is the server name
		'----------------------------------------------------------------
		ServerName = objArgs(0)
		'---------------------------------------
		'--- prompt the user for the sa password
		'---------------------------------------
		saPassword = InputBox("Enter the 'sa' password",Test_Name)
				If saPassword = "" Then
			saPassword = "Blank"
		End If
	Case 2
		'---------------------------------------------------
		'--- the user passed 2 arguments, so try to use them
		'---------------------------------------------------
		ServerName = objArgs(0)
		saPassword = objArgs(1)
				If saPassword = "" Then
			saPassword = "Blank"
		End If
End Select
'-------------------------------------------------------
'--- build the SQL Server login string
'-------------------------------------------------------
If saPassword = "Blank" Then
	strSQL_Login = "-E "
Else
	strSQL_Login = "-Usa -P" & saPassword
End If
'-------------------------------------------------------
'--- setup the objects for the concatenated results file
'-------------------------------------------------------
Set Results_FSO = CreateObject("Scripting.FileSystemObject")
Set Results_File = Results_FSO.CreateTextFile(AcidProcDirectory & "AcidProc.out",true)
'------------------------
'--- now get to work
'------------------------
wScript.Echo ""
wScript.Echo Status_Line
For i = 0 to UBOUND(AcidProcArray)
	wScript.Echo ""
	wScript.Echo "Installing " & AcidProcArray(i) & "..."
	Cmd_String = "SQLCMD " & strSQL_Login & " -S" & ServerName & " -e -i" & AcidProcDirectory & "scripts\" & AcidProcArray(i) & ".sql -o" & AcidProcDirectory & AcidProcArray(i) & ".out"
	Set oExec = WshShell.Exec(CMD_String)
	Do While oExec.Status = 0
		WScript.Sleep 100
	Loop
	rc = CheckSQLOutput(AcidProcDirectory & AcidProcArray(i) & ".out")
	If rc <> 0 Then
		Wscript.Quit
	End If
	Set Temp_Results_File = Results_FSO.OpenTextFile(AcidProcDirectory & AcidProcArray(i) & ".out")
	Do While Temp_Results_File.AtEndOfStream <> True
		'----------------------------------------------------------------
		'--- read in a line and write it to the concatenated results file
		'----------------------------------------------------------------
		Results_File.WriteLine Temp_Results_File.ReadLine
	Loop
	Temp_Results_File.Close
	'------------------------------------
	'--- now remove the temporary file
	'------------------------------------
	Results_FSO.DeleteFile(AcidProcDirectory & AcidProcArray(i) & ".out")
Next
Results_File.Close
wScript.Echo ""
wScript.Echo "****************************************************************************"
wScript.Echo "*                                                                          *"
wScript.Echo "*  Microsoft TPC-E Benchmark Kit Ver." & Kit_Version & "                          *"
wScript.Echo "*                                                                          *"
wScript.Echo Footer_Line
wScript.Echo "*                                                                          *"
wScript.Echo "****************************************************************************"
wScript.Quit(0)
'---------------------------------------------------
'--- define function to check for any error messages
'---------------------------------------------------
Function CheckSQLOutput(SQL_Out)
	ErrorFlag = 0
	Set SQL_fso = CreateObject("Scripting.FileSystemObject")
	Set SQL_Out_File = SQL_fso.OpenTextFile(SQL_Out,1)
	Do While SQL_Out_File.AtEndOfStream <> True
		SQL_Line = SQL_Out_File.ReadLine
		'first check to see if SQL Server is running
		If InStr(SQL_Line, "[Shared Memory]General network error.") Then
			'display the messages and get out of here
			ErrorFlag = 1
			Wscript.Echo "SQL Server does not appear to be active on " & ServerName & "."
			Wscript.Echo "Please check the SQL Server instance and restart the ACID Procedures installation."
		End If
		'next check to see if the output contains a message about the login password
		If InStr(SQL_Line, "Login failed") Then
			'display the messages and get out of here
			ErrorFlag = 1
			Wscript.Echo "The login for userid 'sa' failed."
			Wscript.Echo "Please restart the ACID Procedures installation."
		End If
    Loop
	SQL_Out_File.Close
	CheckSQLOutput = ErrorFlag
End Function
'---------------------------------------------------
'--- end function
'---------------------------------------------------
